/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	TraceItem
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.kernel.trace;

import java.util.ArrayList;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import jp.co.ntt.lms.lo.scorm.util.SG;
import jp.co.ntt.lms.lo.scorm.kernel.exception.SystemException;
import jp.co.ntt.lms.lo.scorm.util.XMLUtil;

/**
 * トレースアイテムクラス 
 */
public class TraceItem {

	/** エレメント名 */
	private String name;

	/** 子エレメントリスト */
	private ArrayList list;

	/** TraceLevel2 */
	private static final int TRACE_LEVEL_2 = 2;

	/** TraceLevel3 */
	private static final int TRACE_LEVEL_3 = 3;

	/** TraceLevel4 */
	private static final int TRACE_LEVEL_4 = 4;

	/** TraceLevel5 */
	private static final int TRACE_LEVEL_5 = 5;

	/**
	 * コンストラクタ
	 * @param name トレースアイテムの規定エレメント名を指定
	 */
	public TraceItem(String name) {
		this.name = name;
		list = new ArrayList();
	}

	/**
	 * エレメント名返却
	 * @return name エレメント名
	 */
	public String getElementName() {
		return name;
	}

	/**
	 * 子エレメント追加
	 * @param name 追加するエレメント名を指定
	 * @param value 追加するテキストを指定
	 */
	public void appendChild(String name, String value) {

		String[] child = new String[2];
		child[0] = name;
		child[1] = value;
		// リストに追加
		list.add(child);
	}

	/**
	 * 子エレメント追加
	 * @param childItem 追加するトレースアイテムを指定
	 */
	public void appendChild(TraceItem childItem) {

		// リストに追加
		list.add(childItem);
	}

	/**
	 * 子エレメント追加
	 * @param childElement 追加するトレースアイテムを指定
	 */
	public void appendChild(Element childElement) {
		// リストに追加
		list.add(childElement);
	}

	/**
	 * 生成したトレースログをDOM Documentで返却
	 * @return 生成したDOM Document
	 */
	public Document getXMLDocument(Document doc) throws SystemException {

		try {
			Element element = doc.getDocumentElement();
			for (int i = 0; i < list.size(); i++) {
				if (list.get(i) instanceof String[]) {
					String[] child = (String[])list.get(i);
					// 内部エレメントに子エレメントを追加
					element.appendChild(XMLUtil.createElement(doc, child[0], child[1]));
				}
				else if (list.get(i) instanceof TraceItem) {
					TraceItem child = (TraceItem)list.get(i);
					element.appendChild(child.getElement(doc));
				}
				else if (list.get(i) instanceof Element) {
					element.appendChild(doc.importNode((Element)list.get(i), true));
				}
			}
		}
		catch (SystemException e) {
			throw e;
		}
		catch (Exception e) {
			throw new SystemException(e);
		}
		return doc;
	}

	/**
	 * 生成したトレースログをエレメントノードで返却
	 * @param doc DOM Documentを指定する
	 * @return 作成したElement
	 */
	private Element getElement(Document doc) throws SystemException {

		try {
			Element element = doc.createElement(name);
			for (int i = 0; i < list.size(); i++) {
				if (list.get(i) instanceof String[]) {
					String[] child = (String[])list.get(i);
					// 内部エレメントに子エレメントを追加
					element.appendChild(XMLUtil.createElement(doc, child[0], child[1]));
				}
				else if (list.get(i) instanceof TraceItem) {
					TraceItem child = (TraceItem)list.get(i);
					element.appendChild(child.getElement(doc));
				}
				else if (list.get(i) instanceof Element) {
					element.appendChild((Element)list.get(i));
				}

			}
			return element;
		}
		catch (SystemException e) {
			throw e;
		}
		catch (Exception e) {
			throw new SystemException(e);
		}
	}

	/**
	 * トレースログ出力条件フラグ
	 * @return トレースログ出力条件判定結果
	 */
	public boolean isValid() throws SystemException {

		try {
			int traceLevel = Integer.parseInt(SG.get("TraceLevel"));
			// <navigate>
			if (name.equalsIgnoreCase("navigate")) {
				// トレースレベルが2以上なら常に出力
				if (traceLevel >= TRACE_LEVEL_2) {
					return true;
				}
				return false;
			}

			// <behavior>
			if (name.equalsIgnoreCase("behavior")) {
				// トレースレベルが3以上なら必ず出力
				if (traceLevel >= TRACE_LEVEL_3) {
					return true;
				}
				return false;
			}

			// <sequencingrule> or <rolluprulecheck>
			if (name.equalsIgnoreCase("sequencingrule") || name.equalsIgnoreCase("rolluprulecheck")) {
				// トレースレベルが3であればルール判定結果を検索
				if (traceLevel == TRACE_LEVEL_3) {
					// 子エレメント中にactionエレメントが存在するかチェック
					return searchChildValue("applied", "true");
				}

				// トレースレベルが4であればactionを検索
				if (traceLevel == TRACE_LEVEL_4) {
					// 子エレメント中にactionエレメントが存在するかチェック
					return searchChildElement("action");
				}

				// トレースレベルが5であれば常に出力
				if (traceLevel == TRACE_LEVEL_5) {
					// トレース出力対象
					return true;
				}

				// トレース出力対象外
				return false;
			}

			// <limitconditionrule>
			if (name.equalsIgnoreCase("limitconditionrule")) {
				// トレースレベルが3であればルール判定結果を検索
				if (traceLevel == TRACE_LEVEL_3) {
					// 子エレメント中にactionエレメントが存在するかチェック
					return searchChildValue("applied", "true");
				}

				// トレースレベルが4であればリミットコンディション判定結果を検索
				if (traceLevel == TRACE_LEVEL_4) {
					// 子エレメント中にlimitconditionエレメントが存在するかチェック
					return searchChildElement("limitcondition");

				}

				// トレースレベルが5であれば常に出力
				if (traceLevel == TRACE_LEVEL_5) {
					// トレース出力対象
					return true;
				}

				// トレース出力対象外
				return false;
			}

			// <limitcondition>
			if (name.equalsIgnoreCase("limitcondition")) {
				// トレースレベルが3･4であればリミットコンディションが教材構造に定義されているかで判断
				if (traceLevel == TRACE_LEVEL_3 || traceLevel == TRACE_LEVEL_4) {
					// 子エレメント中にconditionエレメントが存在するかチェック
					return searchChildElement("condition");
				}

				// トレースレベルが5であれば常に出力
				if (traceLevel == TRACE_LEVEL_5) {
					// トレース出力対象
					return true;
				}

				// トレース出力対象外
				return false;
			}

			// <editactivityinformation>
			if (name.equalsIgnoreCase("editactivityinformation")) {
				// トレースレベルが3･4でアクティビティID（必須）と
				// オブジェクトID（任意）を除く項目を一つ以上登録した場合に出力。
				if (traceLevel == TRACE_LEVEL_3 || traceLevel == TRACE_LEVEL_4) {
					int listcount = 0;
					for (int i = 0; i < list.size(); i++) {
						if (list.get(i) instanceof String[]) {
							String[] child = (String[])list.get(i);
							// 子エレメントがobjectiveidでなかったらカウント
							if (!child[0].equals("objectiveid")) {
								listcount++;
							}
						}
						else
							//子エレメントが子を持つエレメントであればカウント
							if (list.get(i) instanceof TraceItem) {
								listcount++;
							}
					}
					// リスト数が必須項目（ActivityID）の数より多い場合はログ出力
					if (listcount > 1) {
						return true;
					}
				}
				// トレースレベルが5なら常に出力
				if (traceLevel == TRACE_LEVEL_5) {
					return true;
				}
				// トレース出力対象外
				return false;
			}

			// <selectchildren> or <randomaizechildren>
			if (name.equalsIgnoreCase("selectchildren") || name.equalsIgnoreCase("randomizechildren")) {

				// トレースレベルが3･4であればtimingエレメントが存在するか判定
				if (traceLevel == TRACE_LEVEL_3 || traceLevel == TRACE_LEVEL_4) {
					// 子エレメント中にtimingエレメントが存在するかチェック
					return this.searchChildElement("timing");
				}

				// トレースレベルが5であれば常に出力
				if (traceLevel == TRACE_LEVEL_5) {
					// トレース出力対象
					return true;
				}

				// トレース出力対象外
				return false;
			}

			// その他の必須エレメント
			return true;
		}
		catch (Exception e) {
			throw new SystemException(e);
		}
	}

	/**
	 * serchChildElement
	 * @param searchElement
	 * @return evaluation
	 */
	private boolean searchChildElement(String searchElement) {
		// 子リスト中に検索対象のエレメントを持つかどうか検索
		for (int i = list.size() - 1; i >= 0; i--) {
			if (list.get(i) instanceof String[]) {
				String[] child = (String[])list.get(i);
				if (child[0].equals(searchElement)) {
					return true;
				}
			}
			if (list.get(i) instanceof TraceItem) {
				if (((TraceItem)list.get(i)).getElementName().equals(searchElement)) {
					return true;
				}
			}
			if (list.get(i) instanceof Element) {
				if (((Element)list.get(i)).getNodeName().equalsIgnoreCase(searchElement)) {
					return true;
				}
			}
		}
		return false;
	}

	/**
	 * searchChildValue
	 * @param searchElement
	 * @param searchValue
	 * @return evaluation
	 */
	private boolean searchChildValue(String searchElement, String searchValue) {
		// 指定した子エレメントの値が検索文字であるかどうか検索
		for (int i = list.size() - 1; i >= 0; i--) {
			if (list.get(i) instanceof String[]) {
				String[] child = (String[])list.get(i);
				if (child[0].equals(searchElement) && child[1].equals(searchValue)) {
					// appliedエレメントの値がtrueなのでトレース出力対象
					return true;
				}
			}
		}
		return false;
	}
}
